<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfAirTicketDefinition ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfAirTicketDefinition
 * @subpackage Arrays
 * @Autor Luis Vasquez
 * @Fecha 20 Agosto 2018
 * @Versión 1.3
 * @Proyecto  Netactica
 */
class ArrayOfAirTicketDefinition extends AbstractStructArrayBase
{
    /**
     * The AirTicketDefinition
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\AirTicketDefinition[]
     */
    public $AirTicketDefinition;
    /**
     * Constructor method for ArrayOfAirTicketDefinition
     * @uses ArrayOfAirTicketDefinition::setAirTicketDefinition()
     * @param \StructType\AirTicketDefinition[] $airTicketDefinition
     */
    public function __construct(array $airTicketDefinition = array())
    {
        $this
            ->setAirTicketDefinition($airTicketDefinition);
    }
    /**
     * Get AirTicketDefinition value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\AirTicketDefinition[]|null
     */
    public function getAirTicketDefinition()
    {
        return isset($this->AirTicketDefinition) ? $this->AirTicketDefinition : null;
    }
    /**
     * Set AirTicketDefinition value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\AirTicketDefinition[] $airTicketDefinition
     * @return \ArrayType\ArrayOfAirTicketDefinition
     */
    public function setAirTicketDefinition(array $airTicketDefinition = array())
    {
        foreach ($airTicketDefinition as $arrayOfAirTicketDefinitionAirTicketDefinitionItem) {
            // validation for constraint: itemType
            if (!$arrayOfAirTicketDefinitionAirTicketDefinitionItem instanceof \StructType\AirTicketDefinition) {
                throw new \InvalidArgumentException(sprintf('The AirTicketDefinition property can only contain items of \StructType\AirTicketDefinition, "%s" given', is_object($arrayOfAirTicketDefinitionAirTicketDefinitionItem) ? get_class($arrayOfAirTicketDefinitionAirTicketDefinitionItem) : gettype($arrayOfAirTicketDefinitionAirTicketDefinitionItem)), __LINE__);
            }
        }
        if (is_null($airTicketDefinition) || (is_array($airTicketDefinition) && empty($airTicketDefinition))) {
            unset($this->AirTicketDefinition);
        } else {
            $this->AirTicketDefinition = $airTicketDefinition;
        }
        return $this;
    }
    /**
     * Add item to AirTicketDefinition value
     * @throws \InvalidArgumentException
     * @param \StructType\AirTicketDefinition $item
     * @return \ArrayType\ArrayOfAirTicketDefinition
     */
    public function addToAirTicketDefinition(\StructType\AirTicketDefinition $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\AirTicketDefinition) {
            throw new \InvalidArgumentException(sprintf('The AirTicketDefinition property can only contain items of \StructType\AirTicketDefinition, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->AirTicketDefinition[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\AirTicketDefinition|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\AirTicketDefinition|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\AirTicketDefinition|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\AirTicketDefinition|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\AirTicketDefinition|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string AirTicketDefinition
     */
    public function getAttributeName()
    {
        return 'AirTicketDefinition';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfAirTicketDefinition
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
