<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfClientHistoryDefinition ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfClientHistoryDefinition
 * @subpackage Arrays
 * @Autor Luis Vasquez
 * @Fecha 20 Agosto 2018
 * @Versión 1.3
 * @Proyecto  Netactica
 */
class ArrayOfClientHistoryDefinition extends AbstractStructArrayBase
{
    /**
     * The ClientHistoryDefinition
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ClientHistoryDefinition[]
     */
    public $ClientHistoryDefinition;
    /**
     * Constructor method for ArrayOfClientHistoryDefinition
     * @uses ArrayOfClientHistoryDefinition::setClientHistoryDefinition()
     * @param \StructType\ClientHistoryDefinition[] $clientHistoryDefinition
     */
    public function __construct(array $clientHistoryDefinition = array())
    {
        $this
            ->setClientHistoryDefinition($clientHistoryDefinition);
    }
    /**
     * Get ClientHistoryDefinition value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ClientHistoryDefinition[]|null
     */
    public function getClientHistoryDefinition()
    {
        return isset($this->ClientHistoryDefinition) ? $this->ClientHistoryDefinition : null;
    }
    /**
     * Set ClientHistoryDefinition value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\ClientHistoryDefinition[] $clientHistoryDefinition
     * @return \ArrayType\ArrayOfClientHistoryDefinition
     */
    public function setClientHistoryDefinition(array $clientHistoryDefinition = array())
    {
        foreach ($clientHistoryDefinition as $arrayOfClientHistoryDefinitionClientHistoryDefinitionItem) {
            // validation for constraint: itemType
            if (!$arrayOfClientHistoryDefinitionClientHistoryDefinitionItem instanceof \StructType\ClientHistoryDefinition) {
                throw new \InvalidArgumentException(sprintf('The ClientHistoryDefinition property can only contain items of \StructType\ClientHistoryDefinition, "%s" given', is_object($arrayOfClientHistoryDefinitionClientHistoryDefinitionItem) ? get_class($arrayOfClientHistoryDefinitionClientHistoryDefinitionItem) : gettype($arrayOfClientHistoryDefinitionClientHistoryDefinitionItem)), __LINE__);
            }
        }
        if (is_null($clientHistoryDefinition) || (is_array($clientHistoryDefinition) && empty($clientHistoryDefinition))) {
            unset($this->ClientHistoryDefinition);
        } else {
            $this->ClientHistoryDefinition = $clientHistoryDefinition;
        }
        return $this;
    }
    /**
     * Add item to ClientHistoryDefinition value
     * @throws \InvalidArgumentException
     * @param \StructType\ClientHistoryDefinition $item
     * @return \ArrayType\ArrayOfClientHistoryDefinition
     */
    public function addToClientHistoryDefinition(\StructType\ClientHistoryDefinition $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ClientHistoryDefinition) {
            throw new \InvalidArgumentException(sprintf('The ClientHistoryDefinition property can only contain items of \StructType\ClientHistoryDefinition, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->ClientHistoryDefinition[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ClientHistoryDefinition|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ClientHistoryDefinition|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ClientHistoryDefinition|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ClientHistoryDefinition|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ClientHistoryDefinition|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ClientHistoryDefinition
     */
    public function getAttributeName()
    {
        return 'ClientHistoryDefinition';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfClientHistoryDefinition
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
