<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfDepositInfoDefinition ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfDepositInfoDefinition
 * @subpackage Arrays
 * @Autor Luis Vasquez
 * @Fecha 20 Agosto 2018
 * @Versión 1.3
 * @Proyecto  Netactica
 */
class ArrayOfDepositInfoDefinition extends AbstractStructArrayBase
{
    /**
     * The DepositInfoDefinition
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\DepositInfoDefinition[]
     */
    public $DepositInfoDefinition;
    /**
     * Constructor method for ArrayOfDepositInfoDefinition
     * @uses ArrayOfDepositInfoDefinition::setDepositInfoDefinition()
     * @param \StructType\DepositInfoDefinition[] $depositInfoDefinition
     */
    public function __construct(array $depositInfoDefinition = array())
    {
        $this
            ->setDepositInfoDefinition($depositInfoDefinition);
    }
    /**
     * Get DepositInfoDefinition value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\DepositInfoDefinition[]|null
     */
    public function getDepositInfoDefinition()
    {
        return isset($this->DepositInfoDefinition) ? $this->DepositInfoDefinition : null;
    }
    /**
     * Set DepositInfoDefinition value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\DepositInfoDefinition[] $depositInfoDefinition
     * @return \ArrayType\ArrayOfDepositInfoDefinition
     */
    public function setDepositInfoDefinition(array $depositInfoDefinition = array())
    {
        foreach ($depositInfoDefinition as $arrayOfDepositInfoDefinitionDepositInfoDefinitionItem) {
            // validation for constraint: itemType
            if (!$arrayOfDepositInfoDefinitionDepositInfoDefinitionItem instanceof \StructType\DepositInfoDefinition) {
                throw new \InvalidArgumentException(sprintf('The DepositInfoDefinition property can only contain items of \StructType\DepositInfoDefinition, "%s" given', is_object($arrayOfDepositInfoDefinitionDepositInfoDefinitionItem) ? get_class($arrayOfDepositInfoDefinitionDepositInfoDefinitionItem) : gettype($arrayOfDepositInfoDefinitionDepositInfoDefinitionItem)), __LINE__);
            }
        }
        if (is_null($depositInfoDefinition) || (is_array($depositInfoDefinition) && empty($depositInfoDefinition))) {
            unset($this->DepositInfoDefinition);
        } else {
            $this->DepositInfoDefinition = $depositInfoDefinition;
        }
        return $this;
    }
    /**
     * Add item to DepositInfoDefinition value
     * @throws \InvalidArgumentException
     * @param \StructType\DepositInfoDefinition $item
     * @return \ArrayType\ArrayOfDepositInfoDefinition
     */
    public function addToDepositInfoDefinition(\StructType\DepositInfoDefinition $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\DepositInfoDefinition) {
            throw new \InvalidArgumentException(sprintf('The DepositInfoDefinition property can only contain items of \StructType\DepositInfoDefinition, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->DepositInfoDefinition[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\DepositInfoDefinition|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\DepositInfoDefinition|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\DepositInfoDefinition|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\DepositInfoDefinition|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\DepositInfoDefinition|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string DepositInfoDefinition
     */
    public function getAttributeName()
    {
        return 'DepositInfoDefinition';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfDepositInfoDefinition
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
