<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfDiscountDefinition ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfDiscountDefinition
 * @subpackage Arrays
 * @Autor Luis Vasquez
 * @Fecha 20 Agosto 2018
 * @Versión 1.3
 * @Proyecto  Netactica
 */
class ArrayOfDiscountDefinition extends AbstractStructArrayBase
{
    /**
     * The DiscountDefinition
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\DiscountDefinition[]
     */
    public $DiscountDefinition;
    /**
     * Constructor method for ArrayOfDiscountDefinition
     * @uses ArrayOfDiscountDefinition::setDiscountDefinition()
     * @param \StructType\DiscountDefinition[] $discountDefinition
     */
    public function __construct(array $discountDefinition = array())
    {
        $this
            ->setDiscountDefinition($discountDefinition);
    }
    /**
     * Get DiscountDefinition value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\DiscountDefinition[]|null
     */
    public function getDiscountDefinition()
    {
        return isset($this->DiscountDefinition) ? $this->DiscountDefinition : null;
    }
    /**
     * Set DiscountDefinition value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\DiscountDefinition[] $discountDefinition
     * @return \ArrayType\ArrayOfDiscountDefinition
     */
    public function setDiscountDefinition(array $discountDefinition = array())
    {
        foreach ($discountDefinition as $arrayOfDiscountDefinitionDiscountDefinitionItem) {
            // validation for constraint: itemType
            if (!$arrayOfDiscountDefinitionDiscountDefinitionItem instanceof \StructType\DiscountDefinition) {
                throw new \InvalidArgumentException(sprintf('The DiscountDefinition property can only contain items of \StructType\DiscountDefinition, "%s" given', is_object($arrayOfDiscountDefinitionDiscountDefinitionItem) ? get_class($arrayOfDiscountDefinitionDiscountDefinitionItem) : gettype($arrayOfDiscountDefinitionDiscountDefinitionItem)), __LINE__);
            }
        }
        if (is_null($discountDefinition) || (is_array($discountDefinition) && empty($discountDefinition))) {
            unset($this->DiscountDefinition);
        } else {
            $this->DiscountDefinition = $discountDefinition;
        }
        return $this;
    }
    /**
     * Add item to DiscountDefinition value
     * @throws \InvalidArgumentException
     * @param \StructType\DiscountDefinition $item
     * @return \ArrayType\ArrayOfDiscountDefinition
     */
    public function addToDiscountDefinition(\StructType\DiscountDefinition $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\DiscountDefinition) {
            throw new \InvalidArgumentException(sprintf('The DiscountDefinition property can only contain items of \StructType\DiscountDefinition, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->DiscountDefinition[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\DiscountDefinition|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\DiscountDefinition|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\DiscountDefinition|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\DiscountDefinition|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\DiscountDefinition|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string DiscountDefinition
     */
    public function getAttributeName()
    {
        return 'DiscountDefinition';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfDiscountDefinition
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
