<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfEntityChangesHistoryDefinition ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfEntityChangesHistoryDefinition
 * @subpackage Arrays
 * @Autor Luis Vasquez
 * @Fecha 20 Agosto 2018
 * @Versión 1.3
 * @Proyecto  Netactica
 */
class ArrayOfEntityChangesHistoryDefinition extends AbstractStructArrayBase
{
    /**
     * The EntityChangesHistoryDefinition
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\EntityChangesHistoryDefinition[]
     */
    public $EntityChangesHistoryDefinition;
    /**
     * Constructor method for ArrayOfEntityChangesHistoryDefinition
     * @uses ArrayOfEntityChangesHistoryDefinition::setEntityChangesHistoryDefinition()
     * @param \StructType\EntityChangesHistoryDefinition[] $entityChangesHistoryDefinition
     */
    public function __construct(array $entityChangesHistoryDefinition = array())
    {
        $this
            ->setEntityChangesHistoryDefinition($entityChangesHistoryDefinition);
    }
    /**
     * Get EntityChangesHistoryDefinition value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\EntityChangesHistoryDefinition[]|null
     */
    public function getEntityChangesHistoryDefinition()
    {
        return isset($this->EntityChangesHistoryDefinition) ? $this->EntityChangesHistoryDefinition : null;
    }
    /**
     * Set EntityChangesHistoryDefinition value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\EntityChangesHistoryDefinition[] $entityChangesHistoryDefinition
     * @return \ArrayType\ArrayOfEntityChangesHistoryDefinition
     */
    public function setEntityChangesHistoryDefinition(array $entityChangesHistoryDefinition = array())
    {
        foreach ($entityChangesHistoryDefinition as $arrayOfEntityChangesHistoryDefinitionEntityChangesHistoryDefinitionItem) {
            // validation for constraint: itemType
            if (!$arrayOfEntityChangesHistoryDefinitionEntityChangesHistoryDefinitionItem instanceof \StructType\EntityChangesHistoryDefinition) {
                throw new \InvalidArgumentException(sprintf('The EntityChangesHistoryDefinition property can only contain items of \StructType\EntityChangesHistoryDefinition, "%s" given', is_object($arrayOfEntityChangesHistoryDefinitionEntityChangesHistoryDefinitionItem) ? get_class($arrayOfEntityChangesHistoryDefinitionEntityChangesHistoryDefinitionItem) : gettype($arrayOfEntityChangesHistoryDefinitionEntityChangesHistoryDefinitionItem)), __LINE__);
            }
        }
        if (is_null($entityChangesHistoryDefinition) || (is_array($entityChangesHistoryDefinition) && empty($entityChangesHistoryDefinition))) {
            unset($this->EntityChangesHistoryDefinition);
        } else {
            $this->EntityChangesHistoryDefinition = $entityChangesHistoryDefinition;
        }
        return $this;
    }
    /**
     * Add item to EntityChangesHistoryDefinition value
     * @throws \InvalidArgumentException
     * @param \StructType\EntityChangesHistoryDefinition $item
     * @return \ArrayType\ArrayOfEntityChangesHistoryDefinition
     */
    public function addToEntityChangesHistoryDefinition(\StructType\EntityChangesHistoryDefinition $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\EntityChangesHistoryDefinition) {
            throw new \InvalidArgumentException(sprintf('The EntityChangesHistoryDefinition property can only contain items of \StructType\EntityChangesHistoryDefinition, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->EntityChangesHistoryDefinition[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\EntityChangesHistoryDefinition|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\EntityChangesHistoryDefinition|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\EntityChangesHistoryDefinition|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\EntityChangesHistoryDefinition|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\EntityChangesHistoryDefinition|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string EntityChangesHistoryDefinition
     */
    public function getAttributeName()
    {
        return 'EntityChangesHistoryDefinition';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfEntityChangesHistoryDefinition
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
