<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfEntityChangesHistoryDetailDefinition ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfEntityChangesHistoryDetailDefinition
 * @subpackage Arrays
 * @Autor Luis Vasquez
 * @Fecha 20 Agosto 2018
 * @Versión 1.3
 * @Proyecto  Netactica
 */
class ArrayOfEntityChangesHistoryDetailDefinition extends AbstractStructArrayBase
{
    /**
     * The EntityChangesHistoryDetailDefinition
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\EntityChangesHistoryDetailDefinition[]
     */
    public $EntityChangesHistoryDetailDefinition;
    /**
     * Constructor method for ArrayOfEntityChangesHistoryDetailDefinition
     * @uses ArrayOfEntityChangesHistoryDetailDefinition::setEntityChangesHistoryDetailDefinition()
     * @param \StructType\EntityChangesHistoryDetailDefinition[] $entityChangesHistoryDetailDefinition
     */
    public function __construct(array $entityChangesHistoryDetailDefinition = array())
    {
        $this
            ->setEntityChangesHistoryDetailDefinition($entityChangesHistoryDetailDefinition);
    }
    /**
     * Get EntityChangesHistoryDetailDefinition value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\EntityChangesHistoryDetailDefinition[]|null
     */
    public function getEntityChangesHistoryDetailDefinition()
    {
        return isset($this->EntityChangesHistoryDetailDefinition) ? $this->EntityChangesHistoryDetailDefinition : null;
    }
    /**
     * Set EntityChangesHistoryDetailDefinition value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\EntityChangesHistoryDetailDefinition[] $entityChangesHistoryDetailDefinition
     * @return \ArrayType\ArrayOfEntityChangesHistoryDetailDefinition
     */
    public function setEntityChangesHistoryDetailDefinition(array $entityChangesHistoryDetailDefinition = array())
    {
        foreach ($entityChangesHistoryDetailDefinition as $arrayOfEntityChangesHistoryDetailDefinitionEntityChangesHistoryDetailDefinitionItem) {
            // validation for constraint: itemType
            if (!$arrayOfEntityChangesHistoryDetailDefinitionEntityChangesHistoryDetailDefinitionItem instanceof \StructType\EntityChangesHistoryDetailDefinition) {
                throw new \InvalidArgumentException(sprintf('The EntityChangesHistoryDetailDefinition property can only contain items of \StructType\EntityChangesHistoryDetailDefinition, "%s" given', is_object($arrayOfEntityChangesHistoryDetailDefinitionEntityChangesHistoryDetailDefinitionItem) ? get_class($arrayOfEntityChangesHistoryDetailDefinitionEntityChangesHistoryDetailDefinitionItem) : gettype($arrayOfEntityChangesHistoryDetailDefinitionEntityChangesHistoryDetailDefinitionItem)), __LINE__);
            }
        }
        if (is_null($entityChangesHistoryDetailDefinition) || (is_array($entityChangesHistoryDetailDefinition) && empty($entityChangesHistoryDetailDefinition))) {
            unset($this->EntityChangesHistoryDetailDefinition);
        } else {
            $this->EntityChangesHistoryDetailDefinition = $entityChangesHistoryDetailDefinition;
        }
        return $this;
    }
    /**
     * Add item to EntityChangesHistoryDetailDefinition value
     * @throws \InvalidArgumentException
     * @param \StructType\EntityChangesHistoryDetailDefinition $item
     * @return \ArrayType\ArrayOfEntityChangesHistoryDetailDefinition
     */
    public function addToEntityChangesHistoryDetailDefinition(\StructType\EntityChangesHistoryDetailDefinition $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\EntityChangesHistoryDetailDefinition) {
            throw new \InvalidArgumentException(sprintf('The EntityChangesHistoryDetailDefinition property can only contain items of \StructType\EntityChangesHistoryDetailDefinition, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->EntityChangesHistoryDetailDefinition[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\EntityChangesHistoryDetailDefinition|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\EntityChangesHistoryDetailDefinition|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\EntityChangesHistoryDetailDefinition|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\EntityChangesHistoryDetailDefinition|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\EntityChangesHistoryDetailDefinition|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string EntityChangesHistoryDetailDefinition
     */
    public function getAttributeName()
    {
        return 'EntityChangesHistoryDetailDefinition';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfEntityChangesHistoryDetailDefinition
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
