<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfHotelCancellationPolicyDefinition ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfHotelCancellationPolicyDefinition
 * @subpackage Arrays
 * @Autor Luis Vasquez
 * @Fecha 20 Agosto 2018
 * @Versión 1.3
 * @Proyecto  Netactica
 */
class ArrayOfHotelCancellationPolicyDefinition extends AbstractStructArrayBase
{
    /**
     * The HotelCancellationPolicyDefinition
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\HotelCancellationPolicyDefinition[]
     */
    public $HotelCancellationPolicyDefinition;
    /**
     * Constructor method for ArrayOfHotelCancellationPolicyDefinition
     * @uses ArrayOfHotelCancellationPolicyDefinition::setHotelCancellationPolicyDefinition()
     * @param \StructType\HotelCancellationPolicyDefinition[] $hotelCancellationPolicyDefinition
     */
    public function __construct(array $hotelCancellationPolicyDefinition = array())
    {
        $this
            ->setHotelCancellationPolicyDefinition($hotelCancellationPolicyDefinition);
    }
    /**
     * Get HotelCancellationPolicyDefinition value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\HotelCancellationPolicyDefinition[]|null
     */
    public function getHotelCancellationPolicyDefinition()
    {
        return isset($this->HotelCancellationPolicyDefinition) ? $this->HotelCancellationPolicyDefinition : null;
    }
    /**
     * Set HotelCancellationPolicyDefinition value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\HotelCancellationPolicyDefinition[] $hotelCancellationPolicyDefinition
     * @return \ArrayType\ArrayOfHotelCancellationPolicyDefinition
     */
    public function setHotelCancellationPolicyDefinition(array $hotelCancellationPolicyDefinition = array())
    {
        foreach ($hotelCancellationPolicyDefinition as $arrayOfHotelCancellationPolicyDefinitionHotelCancellationPolicyDefinitionItem) {
            // validation for constraint: itemType
            if (!$arrayOfHotelCancellationPolicyDefinitionHotelCancellationPolicyDefinitionItem instanceof \StructType\HotelCancellationPolicyDefinition) {
                throw new \InvalidArgumentException(sprintf('The HotelCancellationPolicyDefinition property can only contain items of \StructType\HotelCancellationPolicyDefinition, "%s" given', is_object($arrayOfHotelCancellationPolicyDefinitionHotelCancellationPolicyDefinitionItem) ? get_class($arrayOfHotelCancellationPolicyDefinitionHotelCancellationPolicyDefinitionItem) : gettype($arrayOfHotelCancellationPolicyDefinitionHotelCancellationPolicyDefinitionItem)), __LINE__);
            }
        }
        if (is_null($hotelCancellationPolicyDefinition) || (is_array($hotelCancellationPolicyDefinition) && empty($hotelCancellationPolicyDefinition))) {
            unset($this->HotelCancellationPolicyDefinition);
        } else {
            $this->HotelCancellationPolicyDefinition = $hotelCancellationPolicyDefinition;
        }
        return $this;
    }
    /**
     * Add item to HotelCancellationPolicyDefinition value
     * @throws \InvalidArgumentException
     * @param \StructType\HotelCancellationPolicyDefinition $item
     * @return \ArrayType\ArrayOfHotelCancellationPolicyDefinition
     */
    public function addToHotelCancellationPolicyDefinition(\StructType\HotelCancellationPolicyDefinition $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\HotelCancellationPolicyDefinition) {
            throw new \InvalidArgumentException(sprintf('The HotelCancellationPolicyDefinition property can only contain items of \StructType\HotelCancellationPolicyDefinition, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->HotelCancellationPolicyDefinition[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\HotelCancellationPolicyDefinition|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\HotelCancellationPolicyDefinition|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\HotelCancellationPolicyDefinition|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\HotelCancellationPolicyDefinition|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\HotelCancellationPolicyDefinition|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string HotelCancellationPolicyDefinition
     */
    public function getAttributeName()
    {
        return 'HotelCancellationPolicyDefinition';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfHotelCancellationPolicyDefinition
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
