<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfHotelDescriptionDefinition ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfHotelDescriptionDefinition
 * @subpackage Arrays
 * @Autor Luis Vasquez
 * @Fecha 20 Agosto 2018
 * @Versión 1.3
 * @Proyecto  Netactica
 */
class ArrayOfHotelDescriptionDefinition extends AbstractStructArrayBase
{
    /**
     * The HotelDescriptionDefinition
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\HotelDescriptionDefinition[]
     */
    public $HotelDescriptionDefinition;
    /**
     * Constructor method for ArrayOfHotelDescriptionDefinition
     * @uses ArrayOfHotelDescriptionDefinition::setHotelDescriptionDefinition()
     * @param \StructType\HotelDescriptionDefinition[] $hotelDescriptionDefinition
     */
    public function __construct(array $hotelDescriptionDefinition = array())
    {
        $this
            ->setHotelDescriptionDefinition($hotelDescriptionDefinition);
    }
    /**
     * Get HotelDescriptionDefinition value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\HotelDescriptionDefinition[]|null
     */
    public function getHotelDescriptionDefinition()
    {
        return isset($this->HotelDescriptionDefinition) ? $this->HotelDescriptionDefinition : null;
    }
    /**
     * Set HotelDescriptionDefinition value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\HotelDescriptionDefinition[] $hotelDescriptionDefinition
     * @return \ArrayType\ArrayOfHotelDescriptionDefinition
     */
    public function setHotelDescriptionDefinition(array $hotelDescriptionDefinition = array())
    {
        foreach ($hotelDescriptionDefinition as $arrayOfHotelDescriptionDefinitionHotelDescriptionDefinitionItem) {
            // validation for constraint: itemType
            if (!$arrayOfHotelDescriptionDefinitionHotelDescriptionDefinitionItem instanceof \StructType\HotelDescriptionDefinition) {
                throw new \InvalidArgumentException(sprintf('The HotelDescriptionDefinition property can only contain items of \StructType\HotelDescriptionDefinition, "%s" given', is_object($arrayOfHotelDescriptionDefinitionHotelDescriptionDefinitionItem) ? get_class($arrayOfHotelDescriptionDefinitionHotelDescriptionDefinitionItem) : gettype($arrayOfHotelDescriptionDefinitionHotelDescriptionDefinitionItem)), __LINE__);
            }
        }
        if (is_null($hotelDescriptionDefinition) || (is_array($hotelDescriptionDefinition) && empty($hotelDescriptionDefinition))) {
            unset($this->HotelDescriptionDefinition);
        } else {
            $this->HotelDescriptionDefinition = $hotelDescriptionDefinition;
        }
        return $this;
    }
    /**
     * Add item to HotelDescriptionDefinition value
     * @throws \InvalidArgumentException
     * @param \StructType\HotelDescriptionDefinition $item
     * @return \ArrayType\ArrayOfHotelDescriptionDefinition
     */
    public function addToHotelDescriptionDefinition(\StructType\HotelDescriptionDefinition $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\HotelDescriptionDefinition) {
            throw new \InvalidArgumentException(sprintf('The HotelDescriptionDefinition property can only contain items of \StructType\HotelDescriptionDefinition, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->HotelDescriptionDefinition[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\HotelDescriptionDefinition|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\HotelDescriptionDefinition|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\HotelDescriptionDefinition|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\HotelDescriptionDefinition|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\HotelDescriptionDefinition|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string HotelDescriptionDefinition
     */
    public function getAttributeName()
    {
        return 'HotelDescriptionDefinition';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfHotelDescriptionDefinition
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
