<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfHotelFacilityDefinition ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfHotelFacilityDefinition
 * @subpackage Arrays
 * @Autor Luis Vasquez
 * @Fecha 20 Agosto 2018
 * @Versión 1.3
 * @Proyecto  Netactica
 */
class ArrayOfHotelFacilityDefinition extends AbstractStructArrayBase
{
    /**
     * The HotelFacilityDefinition
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\HotelFacilityDefinition[]
     */
    public $HotelFacilityDefinition;
    /**
     * Constructor method for ArrayOfHotelFacilityDefinition
     * @uses ArrayOfHotelFacilityDefinition::setHotelFacilityDefinition()
     * @param \StructType\HotelFacilityDefinition[] $hotelFacilityDefinition
     */
    public function __construct(array $hotelFacilityDefinition = array())
    {
        $this
            ->setHotelFacilityDefinition($hotelFacilityDefinition);
    }
    /**
     * Get HotelFacilityDefinition value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\HotelFacilityDefinition[]|null
     */
    public function getHotelFacilityDefinition()
    {
        return isset($this->HotelFacilityDefinition) ? $this->HotelFacilityDefinition : null;
    }
    /**
     * Set HotelFacilityDefinition value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\HotelFacilityDefinition[] $hotelFacilityDefinition
     * @return \ArrayType\ArrayOfHotelFacilityDefinition
     */
    public function setHotelFacilityDefinition(array $hotelFacilityDefinition = array())
    {
        foreach ($hotelFacilityDefinition as $arrayOfHotelFacilityDefinitionHotelFacilityDefinitionItem) {
            // validation for constraint: itemType
            if (!$arrayOfHotelFacilityDefinitionHotelFacilityDefinitionItem instanceof \StructType\HotelFacilityDefinition) {
                throw new \InvalidArgumentException(sprintf('The HotelFacilityDefinition property can only contain items of \StructType\HotelFacilityDefinition, "%s" given', is_object($arrayOfHotelFacilityDefinitionHotelFacilityDefinitionItem) ? get_class($arrayOfHotelFacilityDefinitionHotelFacilityDefinitionItem) : gettype($arrayOfHotelFacilityDefinitionHotelFacilityDefinitionItem)), __LINE__);
            }
        }
        if (is_null($hotelFacilityDefinition) || (is_array($hotelFacilityDefinition) && empty($hotelFacilityDefinition))) {
            unset($this->HotelFacilityDefinition);
        } else {
            $this->HotelFacilityDefinition = $hotelFacilityDefinition;
        }
        return $this;
    }
    /**
     * Add item to HotelFacilityDefinition value
     * @throws \InvalidArgumentException
     * @param \StructType\HotelFacilityDefinition $item
     * @return \ArrayType\ArrayOfHotelFacilityDefinition
     */
    public function addToHotelFacilityDefinition(\StructType\HotelFacilityDefinition $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\HotelFacilityDefinition) {
            throw new \InvalidArgumentException(sprintf('The HotelFacilityDefinition property can only contain items of \StructType\HotelFacilityDefinition, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->HotelFacilityDefinition[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\HotelFacilityDefinition|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\HotelFacilityDefinition|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\HotelFacilityDefinition|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\HotelFacilityDefinition|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\HotelFacilityDefinition|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string HotelFacilityDefinition
     */
    public function getAttributeName()
    {
        return 'HotelFacilityDefinition';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfHotelFacilityDefinition
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
