<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfHotelInfoRoomTypeDefinition ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfHotelInfoRoomTypeDefinition
 * @subpackage Arrays
 * @Autor Luis Vasquez
 * @Fecha 20 Agosto 2018
 * @Versión 1.3
 * @Proyecto  Netactica
 */
class ArrayOfHotelInfoRoomTypeDefinition extends AbstractStructArrayBase
{
    /**
     * The HotelInfoRoomTypeDefinition
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\HotelInfoRoomTypeDefinition[]
     */
    public $HotelInfoRoomTypeDefinition;
    /**
     * Constructor method for ArrayOfHotelInfoRoomTypeDefinition
     * @uses ArrayOfHotelInfoRoomTypeDefinition::setHotelInfoRoomTypeDefinition()
     * @param \StructType\HotelInfoRoomTypeDefinition[] $hotelInfoRoomTypeDefinition
     */
    public function __construct(array $hotelInfoRoomTypeDefinition = array())
    {
        $this
            ->setHotelInfoRoomTypeDefinition($hotelInfoRoomTypeDefinition);
    }
    /**
     * Get HotelInfoRoomTypeDefinition value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\HotelInfoRoomTypeDefinition[]|null
     */
    public function getHotelInfoRoomTypeDefinition()
    {
        return isset($this->HotelInfoRoomTypeDefinition) ? $this->HotelInfoRoomTypeDefinition : null;
    }
    /**
     * Set HotelInfoRoomTypeDefinition value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\HotelInfoRoomTypeDefinition[] $hotelInfoRoomTypeDefinition
     * @return \ArrayType\ArrayOfHotelInfoRoomTypeDefinition
     */
    public function setHotelInfoRoomTypeDefinition(array $hotelInfoRoomTypeDefinition = array())
    {
        foreach ($hotelInfoRoomTypeDefinition as $arrayOfHotelInfoRoomTypeDefinitionHotelInfoRoomTypeDefinitionItem) {
            // validation for constraint: itemType
            if (!$arrayOfHotelInfoRoomTypeDefinitionHotelInfoRoomTypeDefinitionItem instanceof \StructType\HotelInfoRoomTypeDefinition) {
                throw new \InvalidArgumentException(sprintf('The HotelInfoRoomTypeDefinition property can only contain items of \StructType\HotelInfoRoomTypeDefinition, "%s" given', is_object($arrayOfHotelInfoRoomTypeDefinitionHotelInfoRoomTypeDefinitionItem) ? get_class($arrayOfHotelInfoRoomTypeDefinitionHotelInfoRoomTypeDefinitionItem) : gettype($arrayOfHotelInfoRoomTypeDefinitionHotelInfoRoomTypeDefinitionItem)), __LINE__);
            }
        }
        if (is_null($hotelInfoRoomTypeDefinition) || (is_array($hotelInfoRoomTypeDefinition) && empty($hotelInfoRoomTypeDefinition))) {
            unset($this->HotelInfoRoomTypeDefinition);
        } else {
            $this->HotelInfoRoomTypeDefinition = $hotelInfoRoomTypeDefinition;
        }
        return $this;
    }
    /**
     * Add item to HotelInfoRoomTypeDefinition value
     * @throws \InvalidArgumentException
     * @param \StructType\HotelInfoRoomTypeDefinition $item
     * @return \ArrayType\ArrayOfHotelInfoRoomTypeDefinition
     */
    public function addToHotelInfoRoomTypeDefinition(\StructType\HotelInfoRoomTypeDefinition $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\HotelInfoRoomTypeDefinition) {
            throw new \InvalidArgumentException(sprintf('The HotelInfoRoomTypeDefinition property can only contain items of \StructType\HotelInfoRoomTypeDefinition, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->HotelInfoRoomTypeDefinition[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\HotelInfoRoomTypeDefinition|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\HotelInfoRoomTypeDefinition|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\HotelInfoRoomTypeDefinition|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\HotelInfoRoomTypeDefinition|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\HotelInfoRoomTypeDefinition|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string HotelInfoRoomTypeDefinition
     */
    public function getAttributeName()
    {
        return 'HotelInfoRoomTypeDefinition';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfHotelInfoRoomTypeDefinition
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
