<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfHotelReservationTracerDefinition ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfHotelReservationTracerDefinition
 * @subpackage Arrays
 * @Autor Luis Vasquez
 * @Fecha 20 Agosto 2018
 * @Versión 1.3
 * @Proyecto  Netactica
 */
class ArrayOfHotelReservationTracerDefinition extends AbstractStructArrayBase
{
    /**
     * The HotelReservationTracerDefinition
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\HotelReservationTracerDefinition[]
     */
    public $HotelReservationTracerDefinition;
    /**
     * Constructor method for ArrayOfHotelReservationTracerDefinition
     * @uses ArrayOfHotelReservationTracerDefinition::setHotelReservationTracerDefinition()
     * @param \StructType\HotelReservationTracerDefinition[] $hotelReservationTracerDefinition
     */
    public function __construct(array $hotelReservationTracerDefinition = array())
    {
        $this
            ->setHotelReservationTracerDefinition($hotelReservationTracerDefinition);
    }
    /**
     * Get HotelReservationTracerDefinition value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\HotelReservationTracerDefinition[]|null
     */
    public function getHotelReservationTracerDefinition()
    {
        return isset($this->HotelReservationTracerDefinition) ? $this->HotelReservationTracerDefinition : null;
    }
    /**
     * Set HotelReservationTracerDefinition value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\HotelReservationTracerDefinition[] $hotelReservationTracerDefinition
     * @return \ArrayType\ArrayOfHotelReservationTracerDefinition
     */
    public function setHotelReservationTracerDefinition(array $hotelReservationTracerDefinition = array())
    {
        foreach ($hotelReservationTracerDefinition as $arrayOfHotelReservationTracerDefinitionHotelReservationTracerDefinitionItem) {
            // validation for constraint: itemType
            if (!$arrayOfHotelReservationTracerDefinitionHotelReservationTracerDefinitionItem instanceof \StructType\HotelReservationTracerDefinition) {
                throw new \InvalidArgumentException(sprintf('The HotelReservationTracerDefinition property can only contain items of \StructType\HotelReservationTracerDefinition, "%s" given', is_object($arrayOfHotelReservationTracerDefinitionHotelReservationTracerDefinitionItem) ? get_class($arrayOfHotelReservationTracerDefinitionHotelReservationTracerDefinitionItem) : gettype($arrayOfHotelReservationTracerDefinitionHotelReservationTracerDefinitionItem)), __LINE__);
            }
        }
        if (is_null($hotelReservationTracerDefinition) || (is_array($hotelReservationTracerDefinition) && empty($hotelReservationTracerDefinition))) {
            unset($this->HotelReservationTracerDefinition);
        } else {
            $this->HotelReservationTracerDefinition = $hotelReservationTracerDefinition;
        }
        return $this;
    }
    /**
     * Add item to HotelReservationTracerDefinition value
     * @throws \InvalidArgumentException
     * @param \StructType\HotelReservationTracerDefinition $item
     * @return \ArrayType\ArrayOfHotelReservationTracerDefinition
     */
    public function addToHotelReservationTracerDefinition(\StructType\HotelReservationTracerDefinition $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\HotelReservationTracerDefinition) {
            throw new \InvalidArgumentException(sprintf('The HotelReservationTracerDefinition property can only contain items of \StructType\HotelReservationTracerDefinition, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->HotelReservationTracerDefinition[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\HotelReservationTracerDefinition|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\HotelReservationTracerDefinition|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\HotelReservationTracerDefinition|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\HotelReservationTracerDefinition|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\HotelReservationTracerDefinition|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string HotelReservationTracerDefinition
     */
    public function getAttributeName()
    {
        return 'HotelReservationTracerDefinition';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfHotelReservationTracerDefinition
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
