<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfHotelRoomBookingDefinition ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfHotelRoomBookingDefinition
 * @subpackage Arrays
 * @Autor Luis Vasquez
 * @Fecha 20 Agosto 2018
 * @Versión 1.3
 * @Proyecto  Netactica
 */
class ArrayOfHotelRoomBookingDefinition extends AbstractStructArrayBase
{
    /**
     * The HotelRoomBookingDefinition
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\HotelRoomBookingDefinition[]
     */
    public $HotelRoomBookingDefinition;
    /**
     * Constructor method for ArrayOfHotelRoomBookingDefinition
     * @uses ArrayOfHotelRoomBookingDefinition::setHotelRoomBookingDefinition()
     * @param \StructType\HotelRoomBookingDefinition[] $hotelRoomBookingDefinition
     */
    public function __construct(array $hotelRoomBookingDefinition = array())
    {
        $this
            ->setHotelRoomBookingDefinition($hotelRoomBookingDefinition);
    }
    /**
     * Get HotelRoomBookingDefinition value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\HotelRoomBookingDefinition[]|null
     */
    public function getHotelRoomBookingDefinition()
    {
        return isset($this->HotelRoomBookingDefinition) ? $this->HotelRoomBookingDefinition : null;
    }
    /**
     * Set HotelRoomBookingDefinition value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\HotelRoomBookingDefinition[] $hotelRoomBookingDefinition
     * @return \ArrayType\ArrayOfHotelRoomBookingDefinition
     */
    public function setHotelRoomBookingDefinition(array $hotelRoomBookingDefinition = array())
    {
        foreach ($hotelRoomBookingDefinition as $arrayOfHotelRoomBookingDefinitionHotelRoomBookingDefinitionItem) {
            // validation for constraint: itemType
            if (!$arrayOfHotelRoomBookingDefinitionHotelRoomBookingDefinitionItem instanceof \StructType\HotelRoomBookingDefinition) {
                throw new \InvalidArgumentException(sprintf('The HotelRoomBookingDefinition property can only contain items of \StructType\HotelRoomBookingDefinition, "%s" given', is_object($arrayOfHotelRoomBookingDefinitionHotelRoomBookingDefinitionItem) ? get_class($arrayOfHotelRoomBookingDefinitionHotelRoomBookingDefinitionItem) : gettype($arrayOfHotelRoomBookingDefinitionHotelRoomBookingDefinitionItem)), __LINE__);
            }
        }
        if (is_null($hotelRoomBookingDefinition) || (is_array($hotelRoomBookingDefinition) && empty($hotelRoomBookingDefinition))) {
            unset($this->HotelRoomBookingDefinition);
        } else {
            $this->HotelRoomBookingDefinition = $hotelRoomBookingDefinition;
        }
        return $this;
    }
    /**
     * Add item to HotelRoomBookingDefinition value
     * @throws \InvalidArgumentException
     * @param \StructType\HotelRoomBookingDefinition $item
     * @return \ArrayType\ArrayOfHotelRoomBookingDefinition
     */
    public function addToHotelRoomBookingDefinition(\StructType\HotelRoomBookingDefinition $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\HotelRoomBookingDefinition) {
            throw new \InvalidArgumentException(sprintf('The HotelRoomBookingDefinition property can only contain items of \StructType\HotelRoomBookingDefinition, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->HotelRoomBookingDefinition[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\HotelRoomBookingDefinition|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\HotelRoomBookingDefinition|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\HotelRoomBookingDefinition|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\HotelRoomBookingDefinition|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\HotelRoomBookingDefinition|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string HotelRoomBookingDefinition
     */
    public function getAttributeName()
    {
        return 'HotelRoomBookingDefinition';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfHotelRoomBookingDefinition
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
