<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfHotelRoomNightPriceDefinition ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfHotelRoomNightPriceDefinition
 * @subpackage Arrays
 * @Autor Luis Vasquez
 * @Fecha 20 Agosto 2018
 * @Versión 1.3
 * @Proyecto  Netactica
 */
class ArrayOfHotelRoomNightPriceDefinition extends AbstractStructArrayBase
{
    /**
     * The HotelRoomNightPriceDefinition
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\HotelRoomNightPriceDefinition[]
     */
    public $HotelRoomNightPriceDefinition;
    /**
     * Constructor method for ArrayOfHotelRoomNightPriceDefinition
     * @uses ArrayOfHotelRoomNightPriceDefinition::setHotelRoomNightPriceDefinition()
     * @param \StructType\HotelRoomNightPriceDefinition[] $hotelRoomNightPriceDefinition
     */
    public function __construct(array $hotelRoomNightPriceDefinition = array())
    {
        $this
            ->setHotelRoomNightPriceDefinition($hotelRoomNightPriceDefinition);
    }
    /**
     * Get HotelRoomNightPriceDefinition value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\HotelRoomNightPriceDefinition[]|null
     */
    public function getHotelRoomNightPriceDefinition()
    {
        return isset($this->HotelRoomNightPriceDefinition) ? $this->HotelRoomNightPriceDefinition : null;
    }
    /**
     * Set HotelRoomNightPriceDefinition value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\HotelRoomNightPriceDefinition[] $hotelRoomNightPriceDefinition
     * @return \ArrayType\ArrayOfHotelRoomNightPriceDefinition
     */
    public function setHotelRoomNightPriceDefinition(array $hotelRoomNightPriceDefinition = array())
    {
        foreach ($hotelRoomNightPriceDefinition as $arrayOfHotelRoomNightPriceDefinitionHotelRoomNightPriceDefinitionItem) {
            // validation for constraint: itemType
            if (!$arrayOfHotelRoomNightPriceDefinitionHotelRoomNightPriceDefinitionItem instanceof \StructType\HotelRoomNightPriceDefinition) {
                throw new \InvalidArgumentException(sprintf('The HotelRoomNightPriceDefinition property can only contain items of \StructType\HotelRoomNightPriceDefinition, "%s" given', is_object($arrayOfHotelRoomNightPriceDefinitionHotelRoomNightPriceDefinitionItem) ? get_class($arrayOfHotelRoomNightPriceDefinitionHotelRoomNightPriceDefinitionItem) : gettype($arrayOfHotelRoomNightPriceDefinitionHotelRoomNightPriceDefinitionItem)), __LINE__);
            }
        }
        if (is_null($hotelRoomNightPriceDefinition) || (is_array($hotelRoomNightPriceDefinition) && empty($hotelRoomNightPriceDefinition))) {
            unset($this->HotelRoomNightPriceDefinition);
        } else {
            $this->HotelRoomNightPriceDefinition = $hotelRoomNightPriceDefinition;
        }
        return $this;
    }
    /**
     * Add item to HotelRoomNightPriceDefinition value
     * @throws \InvalidArgumentException
     * @param \StructType\HotelRoomNightPriceDefinition $item
     * @return \ArrayType\ArrayOfHotelRoomNightPriceDefinition
     */
    public function addToHotelRoomNightPriceDefinition(\StructType\HotelRoomNightPriceDefinition $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\HotelRoomNightPriceDefinition) {
            throw new \InvalidArgumentException(sprintf('The HotelRoomNightPriceDefinition property can only contain items of \StructType\HotelRoomNightPriceDefinition, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->HotelRoomNightPriceDefinition[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\HotelRoomNightPriceDefinition|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\HotelRoomNightPriceDefinition|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\HotelRoomNightPriceDefinition|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\HotelRoomNightPriceDefinition|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\HotelRoomNightPriceDefinition|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string HotelRoomNightPriceDefinition
     */
    public function getAttributeName()
    {
        return 'HotelRoomNightPriceDefinition';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfHotelRoomNightPriceDefinition
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
