<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfPassengerCountDefinition ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfPassengerCountDefinition
 * @subpackage Arrays
 * @Autor Luis Vasquez
 * @Fecha 20 Agosto 2018
 * @Versión 1.3
 * @Proyecto  Netactica
 */
class ArrayOfPassengerCountDefinition extends AbstractStructArrayBase
{
    /**
     * The PassengerCountDefinition
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\PassengerCountDefinition[]
     */
    public $PassengerCountDefinition;
    /**
     * Constructor method for ArrayOfPassengerCountDefinition
     * @uses ArrayOfPassengerCountDefinition::setPassengerCountDefinition()
     * @param \StructType\PassengerCountDefinition[] $passengerCountDefinition
     */
    public function __construct(array $passengerCountDefinition = array())
    {
        $this
            ->setPassengerCountDefinition($passengerCountDefinition);
    }
    /**
     * Get PassengerCountDefinition value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\PassengerCountDefinition[]|null
     */
    public function getPassengerCountDefinition()
    {
        return isset($this->PassengerCountDefinition) ? $this->PassengerCountDefinition : null;
    }
    /**
     * Set PassengerCountDefinition value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\PassengerCountDefinition[] $passengerCountDefinition
     * @return \ArrayType\ArrayOfPassengerCountDefinition
     */
    public function setPassengerCountDefinition(array $passengerCountDefinition = array())
    {
        foreach ($passengerCountDefinition as $arrayOfPassengerCountDefinitionPassengerCountDefinitionItem) {
            // validation for constraint: itemType
            if (!$arrayOfPassengerCountDefinitionPassengerCountDefinitionItem instanceof \StructType\PassengerCountDefinition) {
                throw new \InvalidArgumentException(sprintf('The PassengerCountDefinition property can only contain items of \StructType\PassengerCountDefinition, "%s" given', is_object($arrayOfPassengerCountDefinitionPassengerCountDefinitionItem) ? get_class($arrayOfPassengerCountDefinitionPassengerCountDefinitionItem) : gettype($arrayOfPassengerCountDefinitionPassengerCountDefinitionItem)), __LINE__);
            }
        }
        if (is_null($passengerCountDefinition) || (is_array($passengerCountDefinition) && empty($passengerCountDefinition))) {
            unset($this->PassengerCountDefinition);
        } else {
            $this->PassengerCountDefinition = $passengerCountDefinition;
        }
        return $this;
    }
    /**
     * Add item to PassengerCountDefinition value
     * @throws \InvalidArgumentException
     * @param \StructType\PassengerCountDefinition $item
     * @return \ArrayType\ArrayOfPassengerCountDefinition
     */
    public function addToPassengerCountDefinition(\StructType\PassengerCountDefinition $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\PassengerCountDefinition) {
            throw new \InvalidArgumentException(sprintf('The PassengerCountDefinition property can only contain items of \StructType\PassengerCountDefinition, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->PassengerCountDefinition[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\PassengerCountDefinition|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\PassengerCountDefinition|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\PassengerCountDefinition|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\PassengerCountDefinition|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\PassengerCountDefinition|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string PassengerCountDefinition
     */
    public function getAttributeName()
    {
        return 'PassengerCountDefinition';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfPassengerCountDefinition
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
