<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfProfileAddressDefinition ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfProfileAddressDefinition
 * @subpackage Arrays
 * @Autor Luis Vasquez
 * @Fecha 20 Agosto 2018
 * @Versión 1.3
 * @Proyecto  Netactica
 */
class ArrayOfProfileAddressDefinition extends AbstractStructArrayBase
{
    /**
     * The ProfileAddressDefinition
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ProfileAddressDefinition[]
     */
    public $ProfileAddressDefinition;
    /**
     * Constructor method for ArrayOfProfileAddressDefinition
     * @uses ArrayOfProfileAddressDefinition::setProfileAddressDefinition()
     * @param \StructType\ProfileAddressDefinition[] $profileAddressDefinition
     */
    public function __construct(array $profileAddressDefinition = array())
    {
        $this
            ->setProfileAddressDefinition($profileAddressDefinition);
    }
    /**
     * Get ProfileAddressDefinition value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ProfileAddressDefinition[]|null
     */
    public function getProfileAddressDefinition()
    {
        return isset($this->ProfileAddressDefinition) ? $this->ProfileAddressDefinition : null;
    }
    /**
     * Set ProfileAddressDefinition value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\ProfileAddressDefinition[] $profileAddressDefinition
     * @return \ArrayType\ArrayOfProfileAddressDefinition
     */
    public function setProfileAddressDefinition(array $profileAddressDefinition = array())
    {
        foreach ($profileAddressDefinition as $arrayOfProfileAddressDefinitionProfileAddressDefinitionItem) {
            // validation for constraint: itemType
            if (!$arrayOfProfileAddressDefinitionProfileAddressDefinitionItem instanceof \StructType\ProfileAddressDefinition) {
                throw new \InvalidArgumentException(sprintf('The ProfileAddressDefinition property can only contain items of \StructType\ProfileAddressDefinition, "%s" given', is_object($arrayOfProfileAddressDefinitionProfileAddressDefinitionItem) ? get_class($arrayOfProfileAddressDefinitionProfileAddressDefinitionItem) : gettype($arrayOfProfileAddressDefinitionProfileAddressDefinitionItem)), __LINE__);
            }
        }
        if (is_null($profileAddressDefinition) || (is_array($profileAddressDefinition) && empty($profileAddressDefinition))) {
            unset($this->ProfileAddressDefinition);
        } else {
            $this->ProfileAddressDefinition = $profileAddressDefinition;
        }
        return $this;
    }
    /**
     * Add item to ProfileAddressDefinition value
     * @throws \InvalidArgumentException
     * @param \StructType\ProfileAddressDefinition $item
     * @return \ArrayType\ArrayOfProfileAddressDefinition
     */
    public function addToProfileAddressDefinition(\StructType\ProfileAddressDefinition $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ProfileAddressDefinition) {
            throw new \InvalidArgumentException(sprintf('The ProfileAddressDefinition property can only contain items of \StructType\ProfileAddressDefinition, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->ProfileAddressDefinition[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ProfileAddressDefinition|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ProfileAddressDefinition|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ProfileAddressDefinition|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ProfileAddressDefinition|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ProfileAddressDefinition|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ProfileAddressDefinition
     */
    public function getAttributeName()
    {
        return 'ProfileAddressDefinition';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfProfileAddressDefinition
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
