<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfProfileEmailDefinition ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfProfileEmailDefinition
 * @subpackage Arrays
 * @Autor Luis Vasquez
 * @Fecha 20 Agosto 2018
 * @Versión 1.3
 * @Proyecto  Netactica
 */
class ArrayOfProfileEmailDefinition extends AbstractStructArrayBase
{
    /**
     * The ProfileEmailDefinition
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ProfileEmailDefinition[]
     */
    public $ProfileEmailDefinition;
    /**
     * Constructor method for ArrayOfProfileEmailDefinition
     * @uses ArrayOfProfileEmailDefinition::setProfileEmailDefinition()
     * @param \StructType\ProfileEmailDefinition[] $profileEmailDefinition
     */
    public function __construct(array $profileEmailDefinition = array())
    {
        $this
            ->setProfileEmailDefinition($profileEmailDefinition);
    }
    /**
     * Get ProfileEmailDefinition value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ProfileEmailDefinition[]|null
     */
    public function getProfileEmailDefinition()
    {
        return isset($this->ProfileEmailDefinition) ? $this->ProfileEmailDefinition : null;
    }
    /**
     * Set ProfileEmailDefinition value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\ProfileEmailDefinition[] $profileEmailDefinition
     * @return \ArrayType\ArrayOfProfileEmailDefinition
     */
    public function setProfileEmailDefinition(array $profileEmailDefinition = array())
    {
        foreach ($profileEmailDefinition as $arrayOfProfileEmailDefinitionProfileEmailDefinitionItem) {
            // validation for constraint: itemType
            if (!$arrayOfProfileEmailDefinitionProfileEmailDefinitionItem instanceof \StructType\ProfileEmailDefinition) {
                throw new \InvalidArgumentException(sprintf('The ProfileEmailDefinition property can only contain items of \StructType\ProfileEmailDefinition, "%s" given', is_object($arrayOfProfileEmailDefinitionProfileEmailDefinitionItem) ? get_class($arrayOfProfileEmailDefinitionProfileEmailDefinitionItem) : gettype($arrayOfProfileEmailDefinitionProfileEmailDefinitionItem)), __LINE__);
            }
        }
        if (is_null($profileEmailDefinition) || (is_array($profileEmailDefinition) && empty($profileEmailDefinition))) {
            unset($this->ProfileEmailDefinition);
        } else {
            $this->ProfileEmailDefinition = $profileEmailDefinition;
        }
        return $this;
    }
    /**
     * Add item to ProfileEmailDefinition value
     * @throws \InvalidArgumentException
     * @param \StructType\ProfileEmailDefinition $item
     * @return \ArrayType\ArrayOfProfileEmailDefinition
     */
    public function addToProfileEmailDefinition(\StructType\ProfileEmailDefinition $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ProfileEmailDefinition) {
            throw new \InvalidArgumentException(sprintf('The ProfileEmailDefinition property can only contain items of \StructType\ProfileEmailDefinition, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->ProfileEmailDefinition[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ProfileEmailDefinition|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ProfileEmailDefinition|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ProfileEmailDefinition|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ProfileEmailDefinition|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ProfileEmailDefinition|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ProfileEmailDefinition
     */
    public function getAttributeName()
    {
        return 'ProfileEmailDefinition';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfProfileEmailDefinition
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
