<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfProfileHierarchyDefinition ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfProfileHierarchyDefinition
 * @subpackage Arrays
 * @Autor Luis Vasquez
 * @Fecha 20 Agosto 2018
 * @Versión 1.3
 * @Proyecto  Netactica
 */
class ArrayOfProfileHierarchyDefinition extends AbstractStructArrayBase
{
    /**
     * The ProfileHierarchyDefinition
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ProfileHierarchyDefinition[]
     */
    public $ProfileHierarchyDefinition;
    /**
     * Constructor method for ArrayOfProfileHierarchyDefinition
     * @uses ArrayOfProfileHierarchyDefinition::setProfileHierarchyDefinition()
     * @param \StructType\ProfileHierarchyDefinition[] $profileHierarchyDefinition
     */
    public function __construct(array $profileHierarchyDefinition = array())
    {
        $this
            ->setProfileHierarchyDefinition($profileHierarchyDefinition);
    }
    /**
     * Get ProfileHierarchyDefinition value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ProfileHierarchyDefinition[]|null
     */
    public function getProfileHierarchyDefinition()
    {
        return isset($this->ProfileHierarchyDefinition) ? $this->ProfileHierarchyDefinition : null;
    }
    /**
     * Set ProfileHierarchyDefinition value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\ProfileHierarchyDefinition[] $profileHierarchyDefinition
     * @return \ArrayType\ArrayOfProfileHierarchyDefinition
     */
    public function setProfileHierarchyDefinition(array $profileHierarchyDefinition = array())
    {
        foreach ($profileHierarchyDefinition as $arrayOfProfileHierarchyDefinitionProfileHierarchyDefinitionItem) {
            // validation for constraint: itemType
            if (!$arrayOfProfileHierarchyDefinitionProfileHierarchyDefinitionItem instanceof \StructType\ProfileHierarchyDefinition) {
                throw new \InvalidArgumentException(sprintf('The ProfileHierarchyDefinition property can only contain items of \StructType\ProfileHierarchyDefinition, "%s" given', is_object($arrayOfProfileHierarchyDefinitionProfileHierarchyDefinitionItem) ? get_class($arrayOfProfileHierarchyDefinitionProfileHierarchyDefinitionItem) : gettype($arrayOfProfileHierarchyDefinitionProfileHierarchyDefinitionItem)), __LINE__);
            }
        }
        if (is_null($profileHierarchyDefinition) || (is_array($profileHierarchyDefinition) && empty($profileHierarchyDefinition))) {
            unset($this->ProfileHierarchyDefinition);
        } else {
            $this->ProfileHierarchyDefinition = $profileHierarchyDefinition;
        }
        return $this;
    }
    /**
     * Add item to ProfileHierarchyDefinition value
     * @throws \InvalidArgumentException
     * @param \StructType\ProfileHierarchyDefinition $item
     * @return \ArrayType\ArrayOfProfileHierarchyDefinition
     */
    public function addToProfileHierarchyDefinition(\StructType\ProfileHierarchyDefinition $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ProfileHierarchyDefinition) {
            throw new \InvalidArgumentException(sprintf('The ProfileHierarchyDefinition property can only contain items of \StructType\ProfileHierarchyDefinition, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->ProfileHierarchyDefinition[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ProfileHierarchyDefinition|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ProfileHierarchyDefinition|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ProfileHierarchyDefinition|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ProfileHierarchyDefinition|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ProfileHierarchyDefinition|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ProfileHierarchyDefinition
     */
    public function getAttributeName()
    {
        return 'ProfileHierarchyDefinition';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfProfileHierarchyDefinition
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
