<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfProfileIpAddressDefinition ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfProfileIpAddressDefinition
 * @subpackage Arrays
 * @Autor Luis Vasquez
 * @Fecha 20 Agosto 2018
 * @Versión 1.3
 * @Proyecto  Netactica
 */
class ArrayOfProfileIpAddressDefinition extends AbstractStructArrayBase
{
    /**
     * The ProfileIpAddressDefinition
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ProfileIpAddressDefinition[]
     */
    public $ProfileIpAddressDefinition;
    /**
     * Constructor method for ArrayOfProfileIpAddressDefinition
     * @uses ArrayOfProfileIpAddressDefinition::setProfileIpAddressDefinition()
     * @param \StructType\ProfileIpAddressDefinition[] $profileIpAddressDefinition
     */
    public function __construct(array $profileIpAddressDefinition = array())
    {
        $this
            ->setProfileIpAddressDefinition($profileIpAddressDefinition);
    }
    /**
     * Get ProfileIpAddressDefinition value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ProfileIpAddressDefinition[]|null
     */
    public function getProfileIpAddressDefinition()
    {
        return isset($this->ProfileIpAddressDefinition) ? $this->ProfileIpAddressDefinition : null;
    }
    /**
     * Set ProfileIpAddressDefinition value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\ProfileIpAddressDefinition[] $profileIpAddressDefinition
     * @return \ArrayType\ArrayOfProfileIpAddressDefinition
     */
    public function setProfileIpAddressDefinition(array $profileIpAddressDefinition = array())
    {
        foreach ($profileIpAddressDefinition as $arrayOfProfileIpAddressDefinitionProfileIpAddressDefinitionItem) {
            // validation for constraint: itemType
            if (!$arrayOfProfileIpAddressDefinitionProfileIpAddressDefinitionItem instanceof \StructType\ProfileIpAddressDefinition) {
                throw new \InvalidArgumentException(sprintf('The ProfileIpAddressDefinition property can only contain items of \StructType\ProfileIpAddressDefinition, "%s" given', is_object($arrayOfProfileIpAddressDefinitionProfileIpAddressDefinitionItem) ? get_class($arrayOfProfileIpAddressDefinitionProfileIpAddressDefinitionItem) : gettype($arrayOfProfileIpAddressDefinitionProfileIpAddressDefinitionItem)), __LINE__);
            }
        }
        if (is_null($profileIpAddressDefinition) || (is_array($profileIpAddressDefinition) && empty($profileIpAddressDefinition))) {
            unset($this->ProfileIpAddressDefinition);
        } else {
            $this->ProfileIpAddressDefinition = $profileIpAddressDefinition;
        }
        return $this;
    }
    /**
     * Add item to ProfileIpAddressDefinition value
     * @throws \InvalidArgumentException
     * @param \StructType\ProfileIpAddressDefinition $item
     * @return \ArrayType\ArrayOfProfileIpAddressDefinition
     */
    public function addToProfileIpAddressDefinition(\StructType\ProfileIpAddressDefinition $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ProfileIpAddressDefinition) {
            throw new \InvalidArgumentException(sprintf('The ProfileIpAddressDefinition property can only contain items of \StructType\ProfileIpAddressDefinition, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->ProfileIpAddressDefinition[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ProfileIpAddressDefinition|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ProfileIpAddressDefinition|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ProfileIpAddressDefinition|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ProfileIpAddressDefinition|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ProfileIpAddressDefinition|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ProfileIpAddressDefinition
     */
    public function getAttributeName()
    {
        return 'ProfileIpAddressDefinition';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfProfileIpAddressDefinition
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
