<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfProfilePhoneDefinition ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfProfilePhoneDefinition
 * @subpackage Arrays
 * @Autor Luis Vasquez
 * @Fecha 20 Agosto 2018
 * @Versión 1.3
 * @Proyecto  Netactica
 */
class ArrayOfProfilePhoneDefinition extends AbstractStructArrayBase
{
    /**
     * The ProfilePhoneDefinition
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ProfilePhoneDefinition[]
     */
    public $ProfilePhoneDefinition;
    /**
     * Constructor method for ArrayOfProfilePhoneDefinition
     * @uses ArrayOfProfilePhoneDefinition::setProfilePhoneDefinition()
     * @param \StructType\ProfilePhoneDefinition[] $profilePhoneDefinition
     */
    public function __construct(array $profilePhoneDefinition = array())
    {
        $this
            ->setProfilePhoneDefinition($profilePhoneDefinition);
    }
    /**
     * Get ProfilePhoneDefinition value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ProfilePhoneDefinition[]|null
     */
    public function getProfilePhoneDefinition()
    {
        return isset($this->ProfilePhoneDefinition) ? $this->ProfilePhoneDefinition : null;
    }
    /**
     * Set ProfilePhoneDefinition value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\ProfilePhoneDefinition[] $profilePhoneDefinition
     * @return \ArrayType\ArrayOfProfilePhoneDefinition
     */
    public function setProfilePhoneDefinition(array $profilePhoneDefinition = array())
    {
        foreach ($profilePhoneDefinition as $arrayOfProfilePhoneDefinitionProfilePhoneDefinitionItem) {
            // validation for constraint: itemType
            if (!$arrayOfProfilePhoneDefinitionProfilePhoneDefinitionItem instanceof \StructType\ProfilePhoneDefinition) {
                throw new \InvalidArgumentException(sprintf('The ProfilePhoneDefinition property can only contain items of \StructType\ProfilePhoneDefinition, "%s" given', is_object($arrayOfProfilePhoneDefinitionProfilePhoneDefinitionItem) ? get_class($arrayOfProfilePhoneDefinitionProfilePhoneDefinitionItem) : gettype($arrayOfProfilePhoneDefinitionProfilePhoneDefinitionItem)), __LINE__);
            }
        }
        if (is_null($profilePhoneDefinition) || (is_array($profilePhoneDefinition) && empty($profilePhoneDefinition))) {
            unset($this->ProfilePhoneDefinition);
        } else {
            $this->ProfilePhoneDefinition = $profilePhoneDefinition;
        }
        return $this;
    }
    /**
     * Add item to ProfilePhoneDefinition value
     * @throws \InvalidArgumentException
     * @param \StructType\ProfilePhoneDefinition $item
     * @return \ArrayType\ArrayOfProfilePhoneDefinition
     */
    public function addToProfilePhoneDefinition(\StructType\ProfilePhoneDefinition $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ProfilePhoneDefinition) {
            throw new \InvalidArgumentException(sprintf('The ProfilePhoneDefinition property can only contain items of \StructType\ProfilePhoneDefinition, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->ProfilePhoneDefinition[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ProfilePhoneDefinition|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ProfilePhoneDefinition|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ProfilePhoneDefinition|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ProfilePhoneDefinition|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ProfilePhoneDefinition|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ProfilePhoneDefinition
     */
    public function getAttributeName()
    {
        return 'ProfilePhoneDefinition';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfProfilePhoneDefinition
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
