<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfTerminalCommandDefinition ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfTerminalCommandDefinition
 * @subpackage Arrays
 * @Autor Luis Vasquez
 * @Fecha 20 Agosto 2018
 * @Versión 1.3
 * @Proyecto  Netactica
 */
class ArrayOfTerminalCommandDefinition extends AbstractStructArrayBase
{
    /**
     * The TerminalCommandDefinition
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\TerminalCommandDefinition[]
     */
    public $TerminalCommandDefinition;
    /**
     * Constructor method for ArrayOfTerminalCommandDefinition
     * @uses ArrayOfTerminalCommandDefinition::setTerminalCommandDefinition()
     * @param \StructType\TerminalCommandDefinition[] $terminalCommandDefinition
     */
    public function __construct(array $terminalCommandDefinition = array())
    {
        $this
            ->setTerminalCommandDefinition($terminalCommandDefinition);
    }
    /**
     * Get TerminalCommandDefinition value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\TerminalCommandDefinition[]|null
     */
    public function getTerminalCommandDefinition()
    {
        return isset($this->TerminalCommandDefinition) ? $this->TerminalCommandDefinition : null;
    }
    /**
     * Set TerminalCommandDefinition value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\TerminalCommandDefinition[] $terminalCommandDefinition
     * @return \ArrayType\ArrayOfTerminalCommandDefinition
     */
    public function setTerminalCommandDefinition(array $terminalCommandDefinition = array())
    {
        foreach ($terminalCommandDefinition as $arrayOfTerminalCommandDefinitionTerminalCommandDefinitionItem) {
            // validation for constraint: itemType
            if (!$arrayOfTerminalCommandDefinitionTerminalCommandDefinitionItem instanceof \StructType\TerminalCommandDefinition) {
                throw new \InvalidArgumentException(sprintf('The TerminalCommandDefinition property can only contain items of \StructType\TerminalCommandDefinition, "%s" given', is_object($arrayOfTerminalCommandDefinitionTerminalCommandDefinitionItem) ? get_class($arrayOfTerminalCommandDefinitionTerminalCommandDefinitionItem) : gettype($arrayOfTerminalCommandDefinitionTerminalCommandDefinitionItem)), __LINE__);
            }
        }
        if (is_null($terminalCommandDefinition) || (is_array($terminalCommandDefinition) && empty($terminalCommandDefinition))) {
            unset($this->TerminalCommandDefinition);
        } else {
            $this->TerminalCommandDefinition = $terminalCommandDefinition;
        }
        return $this;
    }
    /**
     * Add item to TerminalCommandDefinition value
     * @throws \InvalidArgumentException
     * @param \StructType\TerminalCommandDefinition $item
     * @return \ArrayType\ArrayOfTerminalCommandDefinition
     */
    public function addToTerminalCommandDefinition(\StructType\TerminalCommandDefinition $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\TerminalCommandDefinition) {
            throw new \InvalidArgumentException(sprintf('The TerminalCommandDefinition property can only contain items of \StructType\TerminalCommandDefinition, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->TerminalCommandDefinition[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\TerminalCommandDefinition|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\TerminalCommandDefinition|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\TerminalCommandDefinition|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\TerminalCommandDefinition|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\TerminalCommandDefinition|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string TerminalCommandDefinition
     */
    public function getAttributeName()
    {
        return 'TerminalCommandDefinition';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfTerminalCommandDefinition
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
