<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfTerminalDataDefinition ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfTerminalDataDefinition
 * @subpackage Arrays
 * @Autor Luis Vasquez
 * @Fecha 20 Agosto 2018
 * @Versión 1.3
 * @Proyecto  Netactica
 */
class ArrayOfTerminalDataDefinition extends AbstractStructArrayBase
{
    /**
     * The TerminalDataDefinition
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\TerminalDataDefinition[]
     */
    public $TerminalDataDefinition;
    /**
     * Constructor method for ArrayOfTerminalDataDefinition
     * @uses ArrayOfTerminalDataDefinition::setTerminalDataDefinition()
     * @param \StructType\TerminalDataDefinition[] $terminalDataDefinition
     */
    public function __construct(array $terminalDataDefinition = array())
    {
        $this
            ->setTerminalDataDefinition($terminalDataDefinition);
    }
    /**
     * Get TerminalDataDefinition value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\TerminalDataDefinition[]|null
     */
    public function getTerminalDataDefinition()
    {
        return isset($this->TerminalDataDefinition) ? $this->TerminalDataDefinition : null;
    }
    /**
     * Set TerminalDataDefinition value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\TerminalDataDefinition[] $terminalDataDefinition
     * @return \ArrayType\ArrayOfTerminalDataDefinition
     */
    public function setTerminalDataDefinition(array $terminalDataDefinition = array())
    {
        foreach ($terminalDataDefinition as $arrayOfTerminalDataDefinitionTerminalDataDefinitionItem) {
            // validation for constraint: itemType
            if (!$arrayOfTerminalDataDefinitionTerminalDataDefinitionItem instanceof \StructType\TerminalDataDefinition) {
                throw new \InvalidArgumentException(sprintf('The TerminalDataDefinition property can only contain items of \StructType\TerminalDataDefinition, "%s" given', is_object($arrayOfTerminalDataDefinitionTerminalDataDefinitionItem) ? get_class($arrayOfTerminalDataDefinitionTerminalDataDefinitionItem) : gettype($arrayOfTerminalDataDefinitionTerminalDataDefinitionItem)), __LINE__);
            }
        }
        if (is_null($terminalDataDefinition) || (is_array($terminalDataDefinition) && empty($terminalDataDefinition))) {
            unset($this->TerminalDataDefinition);
        } else {
            $this->TerminalDataDefinition = $terminalDataDefinition;
        }
        return $this;
    }
    /**
     * Add item to TerminalDataDefinition value
     * @throws \InvalidArgumentException
     * @param \StructType\TerminalDataDefinition $item
     * @return \ArrayType\ArrayOfTerminalDataDefinition
     */
    public function addToTerminalDataDefinition(\StructType\TerminalDataDefinition $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\TerminalDataDefinition) {
            throw new \InvalidArgumentException(sprintf('The TerminalDataDefinition property can only contain items of \StructType\TerminalDataDefinition, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->TerminalDataDefinition[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\TerminalDataDefinition|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\TerminalDataDefinition|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\TerminalDataDefinition|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\TerminalDataDefinition|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\TerminalDataDefinition|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string TerminalDataDefinition
     */
    public function getAttributeName()
    {
        return 'TerminalDataDefinition';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfTerminalDataDefinition
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
