<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfTerminalPreferencesDefinition ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfTerminalPreferencesDefinition
 * @subpackage Arrays
 * @Autor Luis Vasquez
 * @Fecha 20 Agosto 2018
 * @Versión 1.3
 * @Proyecto  Netactica
 */
class ArrayOfTerminalPreferencesDefinition extends AbstractStructArrayBase
{
    /**
     * The TerminalPreferencesDefinition
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\TerminalPreferencesDefinition[]
     */
    public $TerminalPreferencesDefinition;
    /**
     * Constructor method for ArrayOfTerminalPreferencesDefinition
     * @uses ArrayOfTerminalPreferencesDefinition::setTerminalPreferencesDefinition()
     * @param \StructType\TerminalPreferencesDefinition[] $terminalPreferencesDefinition
     */
    public function __construct(array $terminalPreferencesDefinition = array())
    {
        $this
            ->setTerminalPreferencesDefinition($terminalPreferencesDefinition);
    }
    /**
     * Get TerminalPreferencesDefinition value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\TerminalPreferencesDefinition[]|null
     */
    public function getTerminalPreferencesDefinition()
    {
        return isset($this->TerminalPreferencesDefinition) ? $this->TerminalPreferencesDefinition : null;
    }
    /**
     * Set TerminalPreferencesDefinition value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\TerminalPreferencesDefinition[] $terminalPreferencesDefinition
     * @return \ArrayType\ArrayOfTerminalPreferencesDefinition
     */
    public function setTerminalPreferencesDefinition(array $terminalPreferencesDefinition = array())
    {
        foreach ($terminalPreferencesDefinition as $arrayOfTerminalPreferencesDefinitionTerminalPreferencesDefinitionItem) {
            // validation for constraint: itemType
            if (!$arrayOfTerminalPreferencesDefinitionTerminalPreferencesDefinitionItem instanceof \StructType\TerminalPreferencesDefinition) {
                throw new \InvalidArgumentException(sprintf('The TerminalPreferencesDefinition property can only contain items of \StructType\TerminalPreferencesDefinition, "%s" given', is_object($arrayOfTerminalPreferencesDefinitionTerminalPreferencesDefinitionItem) ? get_class($arrayOfTerminalPreferencesDefinitionTerminalPreferencesDefinitionItem) : gettype($arrayOfTerminalPreferencesDefinitionTerminalPreferencesDefinitionItem)), __LINE__);
            }
        }
        if (is_null($terminalPreferencesDefinition) || (is_array($terminalPreferencesDefinition) && empty($terminalPreferencesDefinition))) {
            unset($this->TerminalPreferencesDefinition);
        } else {
            $this->TerminalPreferencesDefinition = $terminalPreferencesDefinition;
        }
        return $this;
    }
    /**
     * Add item to TerminalPreferencesDefinition value
     * @throws \InvalidArgumentException
     * @param \StructType\TerminalPreferencesDefinition $item
     * @return \ArrayType\ArrayOfTerminalPreferencesDefinition
     */
    public function addToTerminalPreferencesDefinition(\StructType\TerminalPreferencesDefinition $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\TerminalPreferencesDefinition) {
            throw new \InvalidArgumentException(sprintf('The TerminalPreferencesDefinition property can only contain items of \StructType\TerminalPreferencesDefinition, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->TerminalPreferencesDefinition[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\TerminalPreferencesDefinition|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\TerminalPreferencesDefinition|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\TerminalPreferencesDefinition|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\TerminalPreferencesDefinition|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\TerminalPreferencesDefinition|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string TerminalPreferencesDefinition
     */
    public function getAttributeName()
    {
        return 'TerminalPreferencesDefinition';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfTerminalPreferencesDefinition
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
