<?php
/**
 * Class which returns the class map definition
 * @package
 */
class ClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'Execute' => '\\StructType\\Execute',
            'HotelReservationRequest' => '\\StructType\\HotelReservationRequest',
            'BaseRequest' => '\\StructType\\BaseRequest',
            'ExecuteResponse' => '\\StructType\\ExecuteResponse',
            'HotelReservationResponse' => '\\StructType\\HotelReservationResponse',
            'RequestSettingsDefinition' => '\\StructType\\RequestSettingsDefinition',
            'ClientIdentifierDefinition' => '\\StructType\\ClientIdentifierDefinition',
            'DocumentIdentifierDefinition' => '\\StructType\\DocumentIdentifierDefinition',
            'RequestSettingsContextDefinition' => '\\StructType\\RequestSettingsContextDefinition',
            'HotelInformationDefinition' => '\\StructType\\HotelInformationDefinition',
            'DataDefinition' => '\\StructType\\DataDefinition',
            'ChildPolicyDefinition' => '\\StructType\\ChildPolicyDefinition',
            'HotelContactDefinition' => '\\StructType\\HotelContactDefinition',
            'HotelAddressDefinition' => '\\StructType\\HotelAddressDefinition',
            'ArrayOfDataDefinition' => '\\ArrayType\\ArrayOfDataDefinition',
            'ArrayOfHotelDescriptionDefinition' => '\\ArrayType\\ArrayOfHotelDescriptionDefinition',
            'HotelDescriptionDefinition' => '\\StructType\\HotelDescriptionDefinition',
            'HotelDestinationDefinition' => '\\StructType\\HotelDestinationDefinition',
            'ArrayOfEntityChangesHistoryDefinition' => '\\ArrayType\\ArrayOfEntityChangesHistoryDefinition',
            'EntityChangesHistoryDefinition' => '\\StructType\\EntityChangesHistoryDefinition',
            'ArrayOfEntityChangesHistoryDetailDefinition' => '\\ArrayType\\ArrayOfEntityChangesHistoryDetailDefinition',
            'EntityChangesHistoryDetailDefinition' => '\\StructType\\EntityChangesHistoryDetailDefinition',
            'ArrayOfHotelFacilityDefinition' => '\\ArrayType\\ArrayOfHotelFacilityDefinition',
            'HotelFacilityDefinition' => '\\StructType\\HotelFacilityDefinition',
            'ArrayOfHotelInfoRoomTypeDefinition' => '\\ArrayType\\ArrayOfHotelInfoRoomTypeDefinition',
            'HotelInfoRoomTypeDefinition' => '\\StructType\\HotelInfoRoomTypeDefinition',
            'ArrayOfImageItemDefinition' => '\\ArrayType\\ArrayOfImageItemDefinition',
            'ImageItemDefinition' => '\\StructType\\ImageItemDefinition',
            'PositionDefinition' => '\\StructType\\PositionDefinition',
            'ArrayOfRoomTypeDefinition' => '\\ArrayType\\ArrayOfRoomTypeDefinition',
            'RoomTypeDefinition' => '\\StructType\\RoomTypeDefinition',
            'CategoryRoomDefinition' => '\\StructType\\CategoryRoomDefinition',
            'HotelRoomBookingDefinition' => '\\StructType\\HotelRoomBookingDefinition',
            'ReservationItemDefinition' => '\\StructType\\ReservationItemDefinition',
            'ProfileCompanyDefinition' => '\\StructType\\ProfileCompanyDefinition',
            'ProfileBaseDefinition' => '\\StructType\\ProfileBaseDefinition',
            'ArrayOfProfileAddressDefinition' => '\\ArrayType\\ArrayOfProfileAddressDefinition',
            'ProfileAddressDefinition' => '\\StructType\\ProfileAddressDefinition',
            'ArrayOfProfileCardDefinition' => '\\ArrayType\\ArrayOfProfileCardDefinition',
            'ProfileCardDefinition' => '\\StructType\\ProfileCardDefinition',
            'ProfileBankDefinition' => '\\StructType\\ProfileBankDefinition',
            'ProfileCardTypeDefinition' => '\\StructType\\ProfileCardTypeDefinition',
            'ArrayOfClientHistoryDefinition' => '\\ArrayType\\ArrayOfClientHistoryDefinition',
            'ClientHistoryDefinition' => '\\StructType\\ClientHistoryDefinition',
            'CasesHistoryDefinition' => '\\StructType\\CasesHistoryDefinition',
            'CallHistoryDefinition' => '\\StructType\\CallHistoryDefinition',
            'QuoteHistoryDefinition' => '\\StructType\\QuoteHistoryDefinition',
            'ReservationsHistoryDefinition' => '\\StructType\\ReservationsHistoryDefinition',
            'ArrayOfReservationsDataHistoryDefinition' => '\\ArrayType\\ArrayOfReservationsDataHistoryDefinition',
            'ReservationsDataHistoryDefinition' => '\\StructType\\ReservationsDataHistoryDefinition',
            'ArrayOfProfileDocumentDefinition' => '\\ArrayType\\ArrayOfProfileDocumentDefinition',
            'ProfileDocumentDefinition' => '\\StructType\\ProfileDocumentDefinition',
            'ArrayOfProfileEmailDefinition' => '\\ArrayType\\ArrayOfProfileEmailDefinition',
            'ProfileEmailDefinition' => '\\StructType\\ProfileEmailDefinition',
            'ArrayOfProfileHierarchyDefinition' => '\\ArrayType\\ArrayOfProfileHierarchyDefinition',
            'ProfileHierarchyDefinition' => '\\StructType\\ProfileHierarchyDefinition',
            'ArrayOfProfileIpAddressDefinition' => '\\ArrayType\\ArrayOfProfileIpAddressDefinition',
            'ProfileIpAddressDefinition' => '\\StructType\\ProfileIpAddressDefinition',
            'ArrayOfProfilePhoneDefinition' => '\\ArrayType\\ArrayOfProfilePhoneDefinition',
            'ProfilePhoneDefinition' => '\\StructType\\ProfilePhoneDefinition',
            'ProfileImageDefinition' => '\\StructType\\ProfileImageDefinition',
            'ArrayOfTerminalDataDefinition' => '\\ArrayType\\ArrayOfTerminalDataDefinition',
            'TerminalDataDefinition' => '\\StructType\\TerminalDataDefinition',
            'ArrayOfTerminalCommandDefinition' => '\\ArrayType\\ArrayOfTerminalCommandDefinition',
            'TerminalCommandDefinition' => '\\StructType\\TerminalCommandDefinition',
            'ArrayOfTerminalPreferencesDefinition' => '\\ArrayType\\ArrayOfTerminalPreferencesDefinition',
            'TerminalPreferencesDefinition' => '\\StructType\\TerminalPreferencesDefinition',
            'BusinessUnitDefinition' => '\\StructType\\BusinessUnitDefinition',
            'ProfilePersonDefinition' => '\\StructType\\ProfilePersonDefinition',
            'SaleChannelDefinition' => '\\StructType\\SaleChannelDefinition',
            'ProviderInfoDefinition' => '\\StructType\\ProviderInfoDefinition',
            'ArrayOfProductDefinition' => '\\ArrayType\\ArrayOfProductDefinition',
            'ProductDefinition' => '\\StructType\\ProductDefinition',
            'ArrayOfReservationItemTravelerDefinition' => '\\ArrayType\\ArrayOfReservationItemTravelerDefinition',
            'ReservationItemTravelerDefinition' => '\\StructType\\ReservationItemTravelerDefinition',
            'AirReservationItemTravelerDefinition' => '\\StructType\\AirReservationItemTravelerDefinition',
            'ArrayOfAirTicketDefinition' => '\\ArrayType\\ArrayOfAirTicketDefinition',
            'AirTicketDefinition' => '\\StructType\\AirTicketDefinition',
            'HotelReservationItemTravelerDefinition' => '\\StructType\\HotelReservationItemTravelerDefinition',
            'ArrayOfHotelCancellationPolicyDefinition' => '\\ArrayType\\ArrayOfHotelCancellationPolicyDefinition',
            'HotelCancellationPolicyDefinition' => '\\StructType\\HotelCancellationPolicyDefinition',
            'CostDefinition' => '\\StructType\\CostDefinition',
            'CurrencyAmountDefinition' => '\\StructType\\CurrencyAmountDefinition',
            'PercentageAmountDefinition' => '\\StructType\\PercentageAmountDefinition',
            'ArrayOfProductTaxDefinition' => '\\ArrayType\\ArrayOfProductTaxDefinition',
            'ProductTaxDefinition' => '\\StructType\\ProductTaxDefinition',
            'ProductPriceDefinition' => '\\StructType\\ProductPriceDefinition',
            'ArrayOfDiscountDefinition' => '\\ArrayType\\ArrayOfDiscountDefinition',
            'DiscountDefinition' => '\\StructType\\DiscountDefinition',
            'ArrayOfProductFeeDefinition' => '\\ArrayType\\ArrayOfProductFeeDefinition',
            'ProductFeeDefinition' => '\\StructType\\ProductFeeDefinition',
            'HotelContractDefinition' => '\\StructType\\HotelContractDefinition',
            'ArrayOfHotelReservationTracerDefinition' => '\\ArrayType\\ArrayOfHotelReservationTracerDefinition',
            'HotelReservationTracerDefinition' => '\\StructType\\HotelReservationTracerDefinition',
            'ReservationTracerBaseDefinition' => '\\StructType\\ReservationTracerBaseDefinition',
            'BaseLoginDefinition' => '\\StructType\\BaseLoginDefinition',
            'ArrayOfRoomOptionDefinition' => '\\ArrayType\\ArrayOfRoomOptionDefinition',
            'RoomOptionDefinition' => '\\StructType\\RoomOptionDefinition',
            'ArrayOfDepositInfoDefinition' => '\\ArrayType\\ArrayOfDepositInfoDefinition',
            'DepositInfoDefinition' => '\\StructType\\DepositInfoDefinition',
            'ArrayOfHotelRoomNightPriceDefinition' => '\\ArrayType\\ArrayOfHotelRoomNightPriceDefinition',
            'HotelRoomNightPriceDefinition' => '\\StructType\\HotelRoomNightPriceDefinition',
            'ArrayOfPassengerCountDefinition' => '\\ArrayType\\ArrayOfPassengerCountDefinition',
            'PassengerCountDefinition' => '\\StructType\\PassengerCountDefinition',
            'HotelSupplierDefinition' => '\\StructType\\HotelSupplierDefinition',
            'HotelPaymentDefinition' => '\\StructType\\HotelPaymentDefinition',
            'AddressDefinition' => '\\StructType\\AddressDefinition',
            'HotelReservationSearchDefinition' => '\\StructType\\HotelReservationSearchDefinition',
            'ArrayOfHotelRoomBookingDefinition' => '\\ArrayType\\ArrayOfHotelRoomBookingDefinition',
            'NetCoreErrorMessage' => '\\StructType\\NetCoreErrorMessage',
            'ArrayOfstring' => '\\ArrayType\\ArrayOfstring',
            'ArrayOfint' => '\\ArrayType\\ArrayOfint',
            'BoardDefinition' => '\\StructType\\BoardDefinition',
            'CreditCardInfoDefinition' => '\\StructType\\CreditCardInfoDefinition',
        );
    }
}
