<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ExecuteResponse StructType
 * @subpackage Structs
 * @Autor Luis Vasquez
 * @Fecha 20 Agosto 2018
 * @Versión 1.3
 * @Proyecto  Netactica
 */
class ExecuteResponse extends AbstractStructBase
{
    /**
     * The ExecuteResult
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\HotelReservationResponse
     */
    public $ExecuteResult;
    /**
     * Constructor method for ExecuteResponse
     * @uses ExecuteResponse::setExecuteResult()
     * @param \StructType\HotelReservationResponse $executeResult
     */
    public function __construct(\StructType\HotelReservationResponse $executeResult = null)
    {
        $this
            ->setExecuteResult($executeResult);
    }
    /**
     * Get ExecuteResult value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\HotelReservationResponse|null
     */
    public function getExecuteResult()
    {
        return isset($this->ExecuteResult) ? $this->ExecuteResult : null;
    }
    /**
     * Set ExecuteResult value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\HotelReservationResponse $executeResult
     * @return \StructType\ExecuteResponse
     */
    public function setExecuteResult(\StructType\HotelReservationResponse $executeResult = null)
    {
        if (is_null($executeResult) || (is_array($executeResult) && empty($executeResult))) {
            unset($this->ExecuteResult);
        } else {
            $this->ExecuteResult = $executeResult;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\ExecuteResponse
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
