<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for HotelContactDefinition StructType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:HotelContactDefinition
 * @subpackage Structs
 * @Autor Luis Vasquez
 * @Fecha 20 Agosto 2018
 * @Versión 1.3
 * @Proyecto  Netactica
 */
class HotelContactDefinition extends AbstractStructBase
{
    /**
     * The Address
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\HotelAddressDefinition
     */
    public $Address;
    /**
     * The Emails
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfDataDefinition
     */
    public $Emails;
    /**
     * The Faxes
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfDataDefinition
     */
    public $Faxes;
    /**
     * The Phones
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfDataDefinition
     */
    public $Phones;
    /**
     * The Webs
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfDataDefinition
     */
    public $Webs;
    /**
     * Constructor method for HotelContactDefinition
     * @uses HotelContactDefinition::setAddress()
     * @uses HotelContactDefinition::setEmails()
     * @uses HotelContactDefinition::setFaxes()
     * @uses HotelContactDefinition::setPhones()
     * @uses HotelContactDefinition::setWebs()
     * @param \StructType\HotelAddressDefinition $address
     * @param \ArrayType\ArrayOfDataDefinition $emails
     * @param \ArrayType\ArrayOfDataDefinition $faxes
     * @param \ArrayType\ArrayOfDataDefinition $phones
     * @param \ArrayType\ArrayOfDataDefinition $webs
     */
    public function __construct(\StructType\HotelAddressDefinition $address = null, \ArrayType\ArrayOfDataDefinition $emails = null, \ArrayType\ArrayOfDataDefinition $faxes = null, \ArrayType\ArrayOfDataDefinition $phones = null, \ArrayType\ArrayOfDataDefinition $webs = null)
    {
        $this
            ->setAddress($address)
            ->setEmails($emails)
            ->setFaxes($faxes)
            ->setPhones($phones)
            ->setWebs($webs);
    }
    /**
     * Get Address value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\HotelAddressDefinition|null
     */
    public function getAddress()
    {
        return isset($this->Address) ? $this->Address : null;
    }
    /**
     * Set Address value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\HotelAddressDefinition $address
     * @return \StructType\HotelContactDefinition
     */
    public function setAddress(\StructType\HotelAddressDefinition $address = null)
    {
        if (is_null($address) || (is_array($address) && empty($address))) {
            unset($this->Address);
        } else {
            $this->Address = $address;
        }
        return $this;
    }
    /**
     * Get Emails value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfDataDefinition|null
     */
    public function getEmails()
    {
        return isset($this->Emails) ? $this->Emails : null;
    }
    /**
     * Set Emails value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfDataDefinition $emails
     * @return \StructType\HotelContactDefinition
     */
    public function setEmails(\ArrayType\ArrayOfDataDefinition $emails = null)
    {
        if (is_null($emails) || (is_array($emails) && empty($emails))) {
            unset($this->Emails);
        } else {
            $this->Emails = $emails;
        }
        return $this;
    }
    /**
     * Get Faxes value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfDataDefinition|null
     */
    public function getFaxes()
    {
        return isset($this->Faxes) ? $this->Faxes : null;
    }
    /**
     * Set Faxes value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfDataDefinition $faxes
     * @return \StructType\HotelContactDefinition
     */
    public function setFaxes(\ArrayType\ArrayOfDataDefinition $faxes = null)
    {
        if (is_null($faxes) || (is_array($faxes) && empty($faxes))) {
            unset($this->Faxes);
        } else {
            $this->Faxes = $faxes;
        }
        return $this;
    }
    /**
     * Get Phones value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfDataDefinition|null
     */
    public function getPhones()
    {
        return isset($this->Phones) ? $this->Phones : null;
    }
    /**
     * Set Phones value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfDataDefinition $phones
     * @return \StructType\HotelContactDefinition
     */
    public function setPhones(\ArrayType\ArrayOfDataDefinition $phones = null)
    {
        if (is_null($phones) || (is_array($phones) && empty($phones))) {
            unset($this->Phones);
        } else {
            $this->Phones = $phones;
        }
        return $this;
    }
    /**
     * Get Webs value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfDataDefinition|null
     */
    public function getWebs()
    {
        return isset($this->Webs) ? $this->Webs : null;
    }
    /**
     * Set Webs value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfDataDefinition $webs
     * @return \StructType\HotelContactDefinition
     */
    public function setWebs(\ArrayType\ArrayOfDataDefinition $webs = null)
    {
        if (is_null($webs) || (is_array($webs) && empty($webs))) {
            unset($this->Webs);
        } else {
            $this->Webs = $webs;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\HotelContactDefinition
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
