<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for HotelDestinationDefinition StructType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:HotelDestinationDefinition
 * @subpackage Structs
 * @Autor Luis Vasquez
 * @Fecha 20 Agosto 2018
 * @Versión 1.3
 * @Proyecto  Netactica
 */
class HotelDestinationDefinition extends DataDefinition
{
    /**
     * The ZoneList
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfDataDefinition
     */
    public $ZoneList;
    /**
     * Constructor method for HotelDestinationDefinition
     * @uses HotelDestinationDefinition::setZoneList()
     * @param \ArrayType\ArrayOfDataDefinition $zoneList
     */
    public function __construct(\ArrayType\ArrayOfDataDefinition $zoneList = null)
    {
        $this
            ->setZoneList($zoneList);
    }
    /**
     * Get ZoneList value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfDataDefinition|null
     */
    public function getZoneList()
    {
        return isset($this->ZoneList) ? $this->ZoneList : null;
    }
    /**
     * Set ZoneList value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfDataDefinition $zoneList
     * @return \StructType\HotelDestinationDefinition
     */
    public function setZoneList(\ArrayType\ArrayOfDataDefinition $zoneList = null)
    {
        if (is_null($zoneList) || (is_array($zoneList) && empty($zoneList))) {
            unset($this->ZoneList);
        } else {
            $this->ZoneList = $zoneList;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\HotelDestinationDefinition
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
