<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for HotelReservationItemTravelerDefinition StructType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:HotelReservationItemTravelerDefinition
 * @subpackage Structs
 * @Autor Luis Vasquez
 * @Fecha 20 Agosto 2018
 * @Versión 1.3
 * @Proyecto  Netactica
 */
class HotelReservationItemTravelerDefinition extends ReservationItemTravelerDefinition
{
    /**
     * The Age
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $Age;
    /**
     * The IndexRoom
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $IndexRoom;
    /**
     * The RoomId
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $RoomId;
    /**
     * Constructor method for HotelReservationItemTravelerDefinition
     * @uses HotelReservationItemTravelerDefinition::setAge()
     * @uses HotelReservationItemTravelerDefinition::setIndexRoom()
     * @uses HotelReservationItemTravelerDefinition::setRoomId()
     * @param int $age
     * @param int $indexRoom
     * @param int $roomId
     */
    public function __construct($age = null, $indexRoom = null, $roomId = null)
    {
        $this
            ->setAge($age)
            ->setIndexRoom($indexRoom)
            ->setRoomId($roomId);
    }
    /**
     * Get Age value
     * @return int|null
     */
    public function getAge()
    {
        return $this->Age;
    }
    /**
     * Set Age value
     * @param int $age
     * @return \StructType\HotelReservationItemTravelerDefinition
     */
    public function setAge($age = null)
    {
        // validation for constraint: int
        if (!is_null($age) && !is_numeric($age)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($age)), __LINE__);
        }
        $this->Age = $age;
        return $this;
    }
    /**
     * Get IndexRoom value
     * @return int|null
     */
    public function getIndexRoom()
    {
        return $this->IndexRoom;
    }
    /**
     * Set IndexRoom value
     * @param int $indexRoom
     * @return \StructType\HotelReservationItemTravelerDefinition
     */
    public function setIndexRoom($indexRoom = null)
    {
        // validation for constraint: int
        if (!is_null($indexRoom) && !is_numeric($indexRoom)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($indexRoom)), __LINE__);
        }
        $this->IndexRoom = $indexRoom;
        return $this;
    }
    /**
     * Get RoomId value
     * @return int|null
     */
    public function getRoomId()
    {
        return $this->RoomId;
    }
    /**
     * Set RoomId value
     * @param int $roomId
     * @return \StructType\HotelReservationItemTravelerDefinition
     */
    public function setRoomId($roomId = null)
    {
        // validation for constraint: int
        if (!is_null($roomId) && !is_numeric($roomId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($roomId)), __LINE__);
        }
        $this->RoomId = $roomId;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\HotelReservationItemTravelerDefinition
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
