<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for NetCoreErrorMessage StructType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:NetCoreErrorMessage
 * @subpackage Structs
 * @Autor Luis Vasquez
 * @Fecha 20 Agosto 2018
 * @Versión 1.3
 * @Proyecto  Netactica
 */
class NetCoreErrorMessage extends AbstractStructBase
{
    /**
     * The ErrorMessage
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $ErrorMessage;
    /**
     * The ErrorNumber
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $ErrorNumber;
    /**
     * The ErrorSource
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $ErrorSource;
    /**
     * The PolicyType
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $PolicyType;
    /**
     * Constructor method for NetCoreErrorMessage
     * @uses NetCoreErrorMessage::setErrorMessage()
     * @uses NetCoreErrorMessage::setErrorNumber()
     * @uses NetCoreErrorMessage::setErrorSource()
     * @uses NetCoreErrorMessage::setPolicyType()
     * @param string $errorMessage
     * @param string $errorNumber
     * @param string $errorSource
     * @param string $policyType
     */
    public function __construct($errorMessage = null, $errorNumber = null, $errorSource = null, $policyType = null)
    {
        $this
            ->setErrorMessage($errorMessage)
            ->setErrorNumber($errorNumber)
            ->setErrorSource($errorSource)
            ->setPolicyType($policyType);
    }
    /**
     * Get ErrorMessage value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getErrorMessage()
    {
        return isset($this->ErrorMessage) ? $this->ErrorMessage : null;
    }
    /**
     * Set ErrorMessage value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $errorMessage
     * @return \StructType\NetCoreErrorMessage
     */
    public function setErrorMessage($errorMessage = null)
    {
        // validation for constraint: string
        if (!is_null($errorMessage) && !is_string($errorMessage)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($errorMessage)), __LINE__);
        }
        if (is_null($errorMessage) || (is_array($errorMessage) && empty($errorMessage))) {
            unset($this->ErrorMessage);
        } else {
            $this->ErrorMessage = $errorMessage;
        }
        return $this;
    }
    /**
     * Get ErrorNumber value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getErrorNumber()
    {
        return isset($this->ErrorNumber) ? $this->ErrorNumber : null;
    }
    /**
     * Set ErrorNumber value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $errorNumber
     * @return \StructType\NetCoreErrorMessage
     */
    public function setErrorNumber($errorNumber = null)
    {
        // validation for constraint: string
        if (!is_null($errorNumber) && !is_string($errorNumber)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($errorNumber)), __LINE__);
        }
        if (is_null($errorNumber) || (is_array($errorNumber) && empty($errorNumber))) {
            unset($this->ErrorNumber);
        } else {
            $this->ErrorNumber = $errorNumber;
        }
        return $this;
    }
    /**
     * Get ErrorSource value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getErrorSource()
    {
        return isset($this->ErrorSource) ? $this->ErrorSource : null;
    }
    /**
     * Set ErrorSource value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $errorSource
     * @return \StructType\NetCoreErrorMessage
     */
    public function setErrorSource($errorSource = null)
    {
        // validation for constraint: string
        if (!is_null($errorSource) && !is_string($errorSource)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($errorSource)), __LINE__);
        }
        if (is_null($errorSource) || (is_array($errorSource) && empty($errorSource))) {
            unset($this->ErrorSource);
        } else {
            $this->ErrorSource = $errorSource;
        }
        return $this;
    }
    /**
     * Get PolicyType value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getPolicyType()
    {
        return isset($this->PolicyType) ? $this->PolicyType : null;
    }
    /**
     * Set PolicyType value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $policyType
     * @return \StructType\NetCoreErrorMessage
     */
    public function setPolicyType($policyType = null)
    {
        // validation for constraint: string
        if (!is_null($policyType) && !is_string($policyType)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($policyType)), __LINE__);
        }
        if (is_null($policyType) || (is_array($policyType) && empty($policyType))) {
            unset($this->PolicyType);
        } else {
            $this->PolicyType = $policyType;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\NetCoreErrorMessage
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
